"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const stream_1 = require("stream");
const async_1 = require("../readers/async");
const tests = require("../tests/index");
class StreamProvider {
    constructor(_settings) {
        this._settings = _settings;
        this._reader = new async_1.default(this._settings);
        this._stream = new stream_1.Readable({
            objectMode: true,
            read: tests.noop,
            destroy: this._reader.destroy.bind(this._reader)
        });
    }
    read(dir) {
        this._reader.onError((error) => {
            this._stream.emit('error', error);
        });
        this._reader.onEntry((entry) => {
            this._stream.push(entry);
        });
        this._reader.onEnd(() => {
            this._stream.push(null);
        });
        this._reader.read(dir);
        return this._stream;
    }
}
exports.default = StreamProvider;
