import * as fsScandir from '@nodelib/fs.scandir';
import { Entry, Errno } from './types/index';
export declare type FilterFunction<T> = (value: T) => boolean;
export declare type DeepFilterFunction = FilterFunction<Entry>;
export declare type EntryFilterFunction = FilterFunction<Entry>;
export declare type ErrorFilterFunction = FilterFunction<Errno>;
export interface Options {
    concurrency?: number;
    deepFilter?: DeepFilterFunction | null;
    entryFilter?: EntryFilterFunction;
    errorFilter?: ErrorFilterFunction;
    followSymbolicLinks?: boolean;
    fs?: Partial<fsScandir.FileSystemAdapter>;
    stats?: boolean;
    throwErrorOnBrokenSymbolicLink?: boolean;
}
export default class Settings {
    private readonly _options;
    private readonly _concurrency;
    private readonly _deepFilter;
    private readonly _entryFilter;
    private readonly _errorFilter;
    private readonly _fsScandirSettings;
    constructor(_options?: Options);
    readonly concurrency: number;
    readonly deepFilter: DeepFilterFunction | null;
    readonly entryFilter: EntryFilterFunction | null;
    readonly errorFilter: ErrorFilterFunction | null;
    readonly fsScandirSettings: fsScandir.Settings;
    private _setDefaultValue;
}
//# sourceMappingURL=settings.d.ts.map