"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const fsScandir = require("@nodelib/fs.scandir");
class Settings {
    constructor(_options = {}) {
        this._options = _options;
        this._concurrency = this._setDefaultValue(this._options.concurrency, Infinity);
        this._deepFilter = this._setDefaultValue(this._options.deepFilter, null);
        this._entryFilter = this._setDefaultValue(this._options.entryFilter, null);
        this._errorFilter = this._setDefaultValue(this._options.errorFilter, null);
        this._fsScandirSettings = new fsScandir.Settings({
            fs: this._options.fs,
            stats: this._options.stats,
            followSymbolicLinks: this._options.followSymbolicLinks,
            throwErrorOnBrokenSymbolicLink: this._options.throwErrorOnBrokenSymbolicLink
        });
    }
    get concurrency() {
        return this._concurrency;
    }
    get deepFilter() {
        return this._deepFilter;
    }
    get entryFilter() {
        return this._entryFilter;
    }
    get errorFilter() {
        return this._errorFilter;
    }
    get fsScandirSettings() {
        return this._fsScandirSettings;
    }
    _setDefaultValue(option, value) {
        return option === undefined ? value : option;
    }
}
exports.default = Settings;
